# -*- coding: cp1252 -*-
# In diesem Programm werden einige Zahlen von berhmten Faktorisierungen
# definiert.
#
# H. Witten, 10.11.2007

# Im 17. Jahrhundert behauptete der franzsische Mnch Marin Mersenne,
# dass 2^67 - 1 eine Primzahl sei. Im Jahr 1903 hielt Frank Nelson Cole,
# ein Mathematikprofessor aus New York einen eigenartigen Vortrag.
# Ohne ein Wort zu sagen, schrieb er an die eine Tafel die Zahl
# 2**67 - 1, auf die andere Tafel schrieb er das Produkt
# 193707721 x 761838257287, setzte ein Gleichheitszeichen zwischen das
# Produkt und die Mersenne-Zahl und ging auf seinen Platz.
# Daraufhin erhielt er von den Zuhrern - alles Mathematiker der AMS -
# standig ovations.

# Aufgabe Teil 1: Zeigen Sie mit dem Python-Interpreter, dass
#                 mersenne = mer1 * mer2 gilt:
mersenne = 2**67 - 1 
mer1 = 193707721
mer2 = 761838257287

# Aufgabe Teil 2: Cole hatte drei Jahre lang jedes Wochenende gerechnet,
#                 bis er die Zahl in ihre Primfaktoren zerlegen konnte.
#                 Versuchen Sie, die Mersenne-Zahl mit cryptool
#                 -> Einzelverfahren -> RSA-Demo -> Faktorisieren
#                 zu zerlegen. Wie lange bentigt der Computer dafr?

# Bei der ersten Verffentlichung zu RSA im Scientific American durch
# durch Martin Gardner wurde die Zahl RSA129 angegeben, die man zur Lsung
# des Krypto-Rtsels "knacken" musste:
RSA129 = 114381625757888867669235779976146612010218296721242362562561842935706935245733897830597123563958705058989075147599290026879543541L

# Rivest, Shamir und Adleman schtzten, dass es 40 Billiarden Jahre dauern
# wrde, um die Zahl in ihre Primfaktoren zu zerlegen. Tatschlich dauerte
# es nur (!) 17 Jahre, dann wurden die Faktoren verffentlicht und damit
# das Krypto-Rtsel gelst:
RSA129p = 3490529510847650949147849619903898133417764638493387843990820577L
RSA129q = 32769132993266709549961988190834461413177642967992942539798288533L

# Aufgabe Teil 3: Zeigen Sie mit dem Python-Interpreter, dass
#                 RSA129 = RSA129p x RSA129q gilt.

# Aufgabe Teil 4: Informieren Sie sich im Internet ber RSA129 (Englisch-
#                 Kenntnisse sind hilfreich):
# http://www.mit.edu:8001/people/warlord/RSA129-announce.txt
# http://en.wikipedia.org/wiki/RSA-129
# http://en.wikipedia.org/wiki/The_Magic_Words_are_Squeamish_Ossifrage

# Aufgabe Teil 5: Versuchen Sie NICHT, RSA129 selber zu zerlegen.
