# -*- coding: cp1252 -*-
# Ver- und Entschlsseln nach RSA mit gegebenem n,d und e
#
# H. Witten 01.02.2005

from string import upper

def modpot(x,y,n):
    '''
    Schnelles (modulares) Potenzieren x^y (mod n)
    nach der Methode "square and multiply".
    Bei jedem Schritt wird modulo n reduziert! '''
    pot=1
    while y > 0:
        if  y % 2 == 1:         # Falls Exponent ungerade:
            pot = (pot * x) % n # Multiplizieren!
            y = y - 1           # Nun ist der Exponent wieder gerade
        else:                   
            x = (x * x) % n     # Quadrieren und
            y = y / 2           # Exponent halbieren
    return pot

if __name__ == '__main__':
    # Schlssel fr RSA (ggf. ndern)
    n = 77
    e = 43
    d = 7

    while 1: # Endlosschleife
        Richtung = raw_input('V)erschlsseln, E)ntschlsseln oder F)ertig? ')
        Richtung = upper(Richtung)
        if Richtung[0] == 'V':
            print 'Nachricht (Zahl) < ', n,'eingeben: ',
            m = input()
            print 'Verschlsselte Nachricht:',modpot(m,e,n)   
        elif Richtung[0] == 'E':
            print 'Chiffre (Zahl) < ', n,'eingeben: ',
            c = input()
            print 'Entschlsselte Nachricht:',modpot(c,d,n)
        else: break        
        print; print 'Fertig!'; print
