# Caesar-Verschluesselung - funktionale Version
# nach einer Anregung von Dr. Hermann Puhlmann und Walter Gussmann
#
# Fehlt noch: Beschraenkung des Wertebereichs auf die Zeichen 'A' bis 'Z'
# bzw. 'a' bis 'z' und der zughoerigen Zahlen auf den Bereich 0..25
#
# Gerald Gamrath, Helmut Witten 15.9.03

import string

def list2string(list):
    'Wandelt eine Liste von Zeichen in einen String'
    if 0 == len(list): return ""
    return list[0]+list2string(list[1:])

def codiere(bstb):
    'Wandelt "A" in 0, ... "Z" in 25'
    return ord(string.upper(bstb))-65

def schiebe_hin(code, schl):
    'Verschluesselt durch Addition modulo 26'
    if (code<0)or(code>26):
        return code
    return (code+schl)%26

def schiebe_her(code, schl):
    'Entschluesselt durch Subtraktion modulo 26'
    if (code<0)or(code>26):
        return code
    return (code+(26-schl))%26

def decodiere(zahl):
    'Wandelt 0 in "A", ..., 25 in "Z"'
    return chr(zahl+65)

def caesar_ver(bstb, schluessel):
    'Caesar-Verschluesselung eines Zeichens, schluessel ist eine Zahl!'
    return decodiere(schiebe_hin(codiere(bstb),schluessel))

def caesar_ent(bstb, schluessel):
    'Caesar-Entschluesselung eines Zeichens, schluessel ist eine Zahl!'
    return decodiere(schiebe_her(codiere(bstb),schluessel))

def caesar_chiffre(wort, schluessel):
    'Verschluesselt wort mit schluessel nach dem Caesar-Verfahren'
    return list2string([caesar_ver(b, schluessel) for b in wort])

def caesar_dechiffre(wort, schluessel):
    'Entschluesselt wort mit schluessel nach dem Caesar-Verfahren'
    return list2string([caesar_ent(b, schluessel) for b in wort])

if __name__ == "__main__":
    schl = 3
    
    Datei = 'klar.txt'
    f = open(Datei,'r')     # Oeffnet die Datei zum Lesen
    eing = f.read()         # Liest die gesamte Datei als String eing ein.
   
    geheim  = caesar_chiffre(eing, schl)
    print geheim
    klar    = caesar_dechiffre(geheim, schl)
    print klar
